<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:param name="targetId">undefined</xsl:param>
	<xsl:param name="operation">undefined</xsl:param>

	<xsl:template match="layout">
		<layout>
			<xsl:choose>
				<xsl:when test="$operation='move'">
					<xsl:apply-templates select="folder" mode="move"/>
				</xsl:when>
				<xsl:when test="$operation='add'">
					<xsl:apply-templates select="folder" mode="add"/>
				</xsl:when>
			</xsl:choose>
		</layout>
	</xsl:template>

	<!-- add templates -->

	<xsl:template match="folder" mode="add">
		<!-- copy the node and the attributes -->
		<xsl:copy>
			<xsl:for-each select="@*">
				<xsl:copy/>
			</xsl:for-each>

			<xsl:if test="not(@immutable='true')">
				<add_target parentID="{@ID}" nextID="{child::*[self::folder or self::channel][position()=1]/@ID}"/>
			</xsl:if>
            
            <xsl:for-each select="folder|channel">
				<xsl:apply-templates mode="add" select="."/>
				<xsl:if test="not(../@immutable='true')">
					<add_target parentID="{../@ID}" nextID="{following-sibling::*[self::folder or self::channel][position()=1]/@ID}"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:copy>
	</xsl:template>


	<xsl:template match="channel" mode="add">
		<xsl:copy-of select="."/>
	</xsl:template>


	<!-- move templates -->
	<xsl:template match="folder" mode="move">
		<!-- copy the node and the attributes -->
		<xsl:copy>
			<xsl:for-each select="@*">
				<xsl:copy/>
			</xsl:for-each>
			<xsl:variable name="firstChildId">
				<xsl:value-of select="child::*[self::folder or self::channel][position()=1]/@ID"/>
			</xsl:variable>
			<xsl:if test="not(@immutable='true') and not($firstChildId=$targetId)">
				<move_target parentID="{@ID}" nextID="{$firstChildId}"/>
			</xsl:if>

			<xsl:for-each select="folder|channel">
				<xsl:apply-templates mode="move" select="."/>
				<xsl:variable name="nextElementId">
					<xsl:value-of select="following-sibling::*[self::folder or self::channel][position()=1]/@ID"/>
				</xsl:variable>
				<xsl:if test="not(../@immutable='true') and not($nextElementId=$targetId or @ID=$targetId)">
					<move_target parentID="{../@ID}" nextID="{$nextElementId}"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="channel" mode="move">
		<xsl:copy-of select="."/>
	</xsl:template>
</xsl:stylesheet>