<?xml version='1.0'?>
<xsl:stylesheet xmlns:up="http://www.uportal.org" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="xml"/>
    <xsl:param name="upgradeMajor">noUpgrade</xsl:param>
    <xsl:param name="upgradeMinor"></xsl:param>

    <xsl:template match="/">
        <statements>
            <xsl:apply-templates select="up:data/up:table/up:rows/up:row" mode="insert"/>
        </statements>
    </xsl:template>

    <xsl:template match="up:row" mode="insert">
        <!--
         | Check the upgrade rules. If the row or table are new generate the SQL
         +-->
        <xsl:if test="
            $upgradeMajor = 'noUpgrade'
            or
            (@sinceMajor &gt; $upgradeMajor or (@sinceMinor &gt; $upgradeMinor and @sinceMajor &gt;= $upgradeMajor))
            or
            (../../@sinceMajor &gt; $upgradeMajor or (../../@sinceMinor &gt; $upgradeMinor and ../../@sinceMajor &gt;= $upgradeMajor))
            ">

            <statement type="insert">
                <xsl:attribute name="name">
                    <xsl:value-of select="../../up:name"/>
                </xsl:attribute>

                <sql>
                    <xsl:text>INSERT INTO </xsl:text>
                    <xsl:value-of select="../../up:name"/>
                    <xsl:text> (</xsl:text>
                    <xsl:for-each select="up:column">
                        <xsl:value-of select="up:name"/>

                        <xsl:if test="position() != last()">
                            <xsl:text>, </xsl:text>
                        </xsl:if>
                    </xsl:for-each>
                    <xsl:text>) VALUES (</xsl:text>
                    <xsl:for-each select="up:column">
                        <xsl:text>?</xsl:text>

                        <xsl:if test="position() != last()">
                            <xsl:text>, </xsl:text>
                        </xsl:if>
                    </xsl:for-each>
                    <xsl:text>)</xsl:text>
                </sql>
                <parameters>
                    <xsl:for-each select="up:column">
                        <parameter>
                            <xsl:attribute name="type">
                                <xsl:value-of select="up:type"/>
                            </xsl:attribute>

                            <xsl:value-of select="up:value"/>
                        </parameter>
                    </xsl:for-each>
                </parameters>
            </statement>
        </xsl:if>
    </xsl:template>

</xsl:stylesheet>
